examples: factor the test suite.

* examples/mfcalc/test, examples/calc++/test: Extract the
	common bits into...
	* examples/test: here.
	(cwd): New.
	Use it to avoid a race on the temporary directory.
	Reported by Jim Meyering.
	* examples/mfcalc/test, examples/calc++/test: Rename into...
	* examples/mfcalc/mfcalc.test, examples/calc++/calc++.test: these.
	* examples/calc++/local.mk, examples/mfcalc/local.mk,
	* examples/local.mk: Adjust.
This commit is contained in:
Akim Demaille
2012-02-17 14:59:23 +01:00
parent c3a2e0e6dd
commit 5a9c6b89d0
7 changed files with 92 additions and 130 deletions

View File

@@ -54,5 +54,5 @@ examples_mfcalc_mfcalc_SOURCES = \
$(mfcalc_sources)
examples_mfcalc_mfcalc_CPPFLAGS = -I$(top_srcdir)/examples/mfcalc
TESTS += examples/mfcalc/test
EXTRA_DIST += examples/mfcalc/test
TESTS += examples/mfcalc/mfcalc.test
EXTRA_DIST += examples/mfcalc/mfcalc.test

27
examples/mfcalc/mfcalc.test Executable file
View File

@@ -0,0 +1,27 @@
#! /bin/sh
# Copyright (C) 2005-2012 Free Software Foundation, Inc.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
cat >input <<EOF
1+2*3
EOF
run 0 7
run 0 7
cat >input <<EOF
(1+2) * 3
EOF
run 0 9

View File

@@ -1,86 +0,0 @@
#! /bin/sh
# Copyright (C) 2005-2012 Free Software Foundation, Inc.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
me=`dirname $0`
me=`basename $me`
# Number of the current test.
number=1
# Exit status of this script.
exit=true
# The exercised program.
prog=../examples/$me/$me
# cleanup
# -------
cleanup ()
{
local status=$?
if test -z "$DEBUG"; then
cd ..
rm -rf $$.dir
fi
exit $status
}
trap cleanup 0 1 2 13 15
mkdir $$.dir
cd $$.dir
# run EXPECTED-EXIT-STATUS EXPECTED-OUTPUT [PARSER-OPTIONS]
# ---------------------------------------------------------
run ()
{
# Expected exit status.
local sta_exp=$1
shift
# Expected output.
local out_exp=$1
shift
$prog "$@" - <input >out_eff
# Effective exit status.
local sta_eff=$?
# Effective output.
local out_eff=`cat out_eff`
if test $sta_eff -eq $sta_exp; then
if test "$out_eff" = "$out_exp"; then
echo "$me: PASS: $number"
else
echo "$me: FAIL: $number (expected output: $out_exp, effective: $out_eff)"
exit=false
fi
else
echo "$me: FAIL: $number (expected status: $sta_exp, effective: $sta_eff)"
exit=false
fi
number=`expr $number + 1`
}
cat >input <<EOF
1+2*3
EOF
run 0 7
run 0 7
cat >input <<EOF
(1+2) * 3
EOF
run 0 9
$exit